;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;  ROSE tools
;;;
;;;                                      Copyright 2001 @ GOMI Hiroshi 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; starts on 2001-9-3

;;;
;;; read MDL file
;;;
(defun read-mdl (file) (read-mdl-aux file nil nil))
(defun read-mdl-aux (file in label)
   (setq in (open file))          ;; mdl t@C̃I[v
   (setq label (read in))         ;; petal Xg̓ǂݍ
   (setq mdl (read in))           ;; design Xg̓ǂݍ
   (close in)                     ;; mdl t@C̃N[Y
   '(commands are (all-classies mdl) (all-loaded-classies))
   )                              ;; ϐ mdl ͍Lϐ 

;;;
;;; get all classies in ROSE list
;;;   NX Class (ClassAttribute) L[ƂăT[`
(defun all-loaded-classies (%list) (search-all 'ClassAttribute %list))
(defun all-classies (%list) (search-all 'Class %list))


;;;
;;; get value for listROSE
;;;   listROSE is (key1 value1 key2 value2 ...) 
(defun getR (key listROSE) (second (member key listROSE)))

;;;
;;; tool group
;;;
(defun defaults (lR) (getR 'Defaults lR))
(defun root-usecase-package (lR) (getR 'root_usecase_package lR))
(defun root-category (lR) (getR 'root_category lR))
(defun root-subsystem (lR) (getR 'root_subsystem lR))
(defun root-structure (lR) (getR 'root_structure lR))
(defun properties (lR) (getR 'properties lR))

;;; for simple
(defun def (lR) (getR 'Defaults lR))
(defun usecase (lR) (getR 'root_usecase_package lR))
(defun category (lR) (getR 'root_category lR))
(defun subsystem (lR) (getR 'root_subsystem lR))
(defun struct (lR) (getR 'root_structure lR))
(defun prop (lR) (getR 'properties lR))


;;;
;;; search-all
;;;
(defun search-all (%item %list) (search-all-aux %item %list nil))
(defun search-all-aux (%item %list %result)
   (if (atom %list) 
       %result
       (if (atom (car %list))
           (if (eq %item (car %list))
;;               (search-all-aux 
;;                  %item (cddr %list) (cons (second %list) %result))
               (cons (second %list) %result)     ;; PSɂ͂P̃NX̂
               (search-all-aux %item (cdr %list) %result))
           (nconc (search-all-aux %item (car %list) %result)
                  (search-all-aux %item (cdr %list) %result)))))

