;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;  eXgP[X
;;;
;;;  
;;; All Right Reserved, 2001 (C) CopyRight by GOMI Hiroshi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 8-Feb-2001: starts
;;;

;;;
;;; Test Case Function
;;;
(setq total 0)

(defun tc (%test-case %result)
   (tc2 %test-case %result nil nil))

(defun tc2 (%test-case %result %ret %ok?)
   (setq %ret (eval %test-case))
   (if (setq %ok? (equal %ret %result))
       (write "O.K. ")
       (write "N.G. "))
   (write %test-case)
   (write " --> ")
   (write %ret)
   (if %ok?
       (terpri)
       (progn (setq total (+ total 1))
              (write " (result is ")
              (write %result)
              (write ".) [][][][][][][]") 
              (terpri))) )

;;;
;;; Test Case Data
;;;

;;; Xg
(tc '(car '(a b c)) 'a)
(tc '(cdr '(a b c)) '(b c))
(tc '(cons 1 2) '(1 . 2))
(tc '(setq list1 '(1 2 3)) '(1 2 3))
(tc '(set-car list1 10) 10)
(tc '(set-cdr list1 '(20 30)) '(20 30))
(tc 'list1 '(10 20 30))
(tc '(second '(1 2 3)) 2)
(tc '(member 3 '(1 2 3)) '(3))
(tc '(nth 3 '(0 1 2 3 4 5)) 3)
(tc '(string= (catch nil (car 1)) "CAR") t)

;;; q
(tc '(eq 'abc 'abc) t)
(tc '(eq 'abc 'def) nil)
(tc '(= 1 1) t)
(tc '(= 1 1.0) t)
(tc '(= 1.0 1.0) t)
(tc '(= 2 3) nil)
(tc '(equal '(a (b c) d) '(a (b c) d)) t)   ;;; bug detected !!!
(tc '(equal '(a (b c) . d) '(a (b c) . d)) t)
(tc '(equal '(a b c . d) '(a b c . e)) nil)

;;; setf
(tc '(setf var1 123) 123)
(tc 'var1 123)

;;; defun
(tc '(defun foo (x y) (cons x y)) 'foo)
(tc '(foo 1 2) '(1 . 2))
(tc '(defun bar (x) (foo x x)) 'bar)
(tc '(bar 10) '(10 . 10))

;;; if 
(tc '(if (> 3 7) 'true 'false) 'false)
(tc '(if t 1 2) 1)

;;; string=
(tc '(string= "abc" "abc") t)
(tc '(string= "aaa" "bbb") nil)
(tc '(string= "ab\"c" "ab\"c") t)

;;; number
(tc '(+ 1 2) 3)
(tc '(+ 1.0 2) 3.0)
(tc '(+ 1 2.0) 3.0)
(tc '(+ 1.0 2.0) 3.0)
(tc '(- 2.0 3.0) -1.0)
(tc '(- -1 -2) 1)
(tc '(- -1.0 -2) 1.0)
(tc '(* 2 3) 6)
(tc '(* -2 -3.0) 6.0)
(tc '(/ 12 5) 2)
(tc '(/ 3.0 2.0) 1.5)

;;; tak
(tc '(tak 15 10 5) 10)
(tc '(tak 18 12 6) 7)

;;; thread
(tc '(threadp (setq th (thread '(setq var 123)))) t)
(tc '(sleep 2000) t)
(tc '(finishp th) t)
(tc '(result th) 123)
(tc '(null (value-of 'var t)) nil)
(tc '(threadp (setq th2 (run th 'var))) t)
(tc '(sleep 2000) t)
(tc '(result th2) 123)

;;; su (}`[U)
(tc '(setq qwe 2222) 2222)
(tc '(progn (su 1) (setq qwe 1111) (su 0)) 0)
(tc 'qwe 2222)

;;; error, catch & throw
(tc '(errorp (error "TEST" 'error-tag 'error-inf)) t)
(tc '(+ (catch 'q (throw 'q 123)) 321) 444)
(tc '(catch 'q (throw (error "TEST" 'q 123))) 123)

;;; CORBA
(tc '(corba) 'start-corba-ok)
(tc '(sleep 2000) t)
(tc '(string= (orb "(+ 1 2)") "3") t)
(tc '(numberp (setq q (regist-callback))) t)
(tc '(callback q 123) t)
(tc '(string= (callback-result) "123") t)

;;; load-class
(tc '(null (java:load-class "warabi.SendString")) nil)
(tc '(string= (java:send-string "warabi.SendString" "sendString" "abc") "abc bye bye bye!") t)


(write "Error number is ")
(write total)
(terpri)
